/* =========================================================
   BLAEK – Custom Keycloak Theme
   ========================================================= */

/* =======================
   Fonts
   ======================= */
@font-face {
    font-family: "Roboto Flex";
    src: url("../fonts/RobotoFlex.ttf") format("truetype");
    font-weight: 100 1000;
    font-style: normal;
    font-display: swap;
}

/* =======================
   Global Variables
   ======================= */
:root {
    /* Brand */
    --color-primary: #0d70b4;
    --color-primary-hover: #317770;
    --color-warning: #fcce34;

    /* Neutral */
    --color-white: #ffffff;
    --color-text-primary: rgb(20, 70, 110);
    --color-text-secondary: #5d666e;
    --color-text-default: #32363b;

    /* Borders & states */
    --color-border-default: #a8aeb4;
    --color-focus-ring: #00589f;
    --color-error: #CC4000;
    --color-border-danger: #CC4000;
    --color-bg-danger: #FBEAEA;
    --color-border-info: #0277BD;
    --color-bg-info: #E5F4FF;
    --color-icon-warning: #AD7D04;
    --color-border-warning: #FCCE34;
    --color-bg-warning: #FEF6DB;
    --color-border-success: #327350;
    --color-bg-success: #E0FAEC;

    --color-link-outline: #32befa;

    --color-background-secondary: #F8F8F9;
    --color-font-otp-title: #14466E;

    /* Button */
    --button-border-width: 2px;
}

.pf-v5-c-alert {
    --pf-v5-c-alert--m-info__title--Color: var(--color-text-default);
    --pf-v5-c-alert--m-info--BorderTopColor: var(--color-border-info);
    --pf-v5-c-alert--m-info__icon--Color: var(--color-border-info);

    --pf-v5-c-alert--m-warning__title--Color: var(--color-text-default);
    --pf-v5-c-alert--m-warning--BorderTopColor: var(--color-border-warning);
    --pf-v5-c-alert--m-warning__icon--Color: var(--color-icon-warning);

    --pf-v5-c-alert--m-danger__title--Color: var(--color-text-default);
    --pf-v5-c-alert--m-danger--BorderTopColor: var(--color-border-danger);
    --pf-v5-c-alert--m-danger__icon--Color: var(--color-border-danger);

    --pf-v5-c-alert--m-inline--m-danger--BackgroundColor: var(--color-bg-danger);
    --pf-v5-c-alert--m-inline--m-warning--BackgroundColor: var(--color-bg-warning);
    --pf-v5-c-alert--m-inline--m-info--BackgroundColor: var(--color-bg-info);
}

/* =======================
   Base styles
   ======================= */
html,
body,
#kc-container,
#kc-container * {
    font-family: "Roboto Flex", sans-serif;
    hyphens: auto;
    overflow-wrap: break-word;
    word-break: break-word;
}

/* Make the whole login screen background white */
html,
body {
    background: var(--color-white) !important;
}

/* PatternFly error */
.pf-m-error {
    color: var(--color-error);
}

.pf-v5-c-form__label-required {
    color: inherit;
}

.kc-input-error-box {
    display: flex;
    font-size: 0.75rem;
    padding: 0.25rem 0.5rem;
    background: var(--color-bg-danger);
    color: var(--color-border-danger);
    gap: 0.75rem;
    align-items: center;
    margin-block-end: 0.125rem;
}

.kc-input-error-icon {
    display: flex;
    align-items: center;
}

.kc-input-error-box .pf-v5-c-helper-text__item-text.pf-m-error {
    margin-block-start: 0;
    color: var(--color-border-danger);
    min-height: 1.25rem;
    line-height: 1.25rem;
    font-size: 0.75rem;
}

.kc-input-wrapper-error .kc-input, .pf-m-error .kc-input {
    border-color: var(--color-border-danger);
}

.pf-v5-c-alert__icon {
    margin-inline-end: 1rem;
}

.pf-m-error .fa-exclamation-circle {
    display: none;
}

.pf-v5-c-alert__title {
    font-weight: 400;
    font-size: 0.875rem;
    align-content: center;
}

.pf-v5-c-form-control__icon {
    padding-block-start: 0.5rem;
}

.pf-v5-c-form-control select {
    border: 1px solid var(--color-border-default);
    height: 40px;
}

.pf-v5-c-form-control select:focus, .pf-v5-c-form-control select:active {
    border: 1px solid var(--color-primary-hover);
    height: 40px;
}

#kc-update-profile-form {
    padding-top: 0;
}

#kc-update-profile-form .pf-v5-u-mb-md-on-md {
    display: none;
}

#kc-passwd-update-form #kc-form-buttons,
#kc-update-email-form #kc-form-buttons,
#kc-verify-email-code-form #kc-form-buttons {
    display: flex;
    justify-content: flex-start;
    gap: 1rem;
}

/* Order buttons: Cancel (visual first) but Submit (form first) */
#kc-update-email-form #kc-form-buttons input[name="submitBtn"],
#kc-verify-email-code-form #kc-form-buttons input[name="verifyBtn"],
#kc-passwd-update-form #kc-form-buttons input[name="login"] {
    order: 2;
}

#kc-update-email-form #kc-form-buttons button[name="cancel-aia"],
#kc-verify-email-code-form #kc-form-buttons button[name="cancel-aia"],
#kc-passwd-update-form #kc-form-buttons button[name="cancel-aia"],
#kc-passwd-update-form #kc-form-buttons a {
    order: 1;
}

.instruction-text {
    margin-top: 1rem;
}

.pf-v5-c-list li + li {
    margin-block-start: 0;
}

#kc-totp-supported-apps {
    list-style-type: disc
}

#kc-totp-settings {
    display: flex;
    flex-direction: column;
    gap: 2rem;
    font-size: 0.875rem;
    padding: 1rem 0;
    color: var(--color-text-default);
}

#kc-totp-settings-form .pf-v5-c-form__group.pf-m-action {
    margin-block-start: 1.5rem;
    margin-block-end: 3rem;
}

.pf-v5-c-login__main-header {
    grid-template-columns: 1fr;
}

/* =======================
   Background
   ======================= */
body#keycloak-bg {
    background-image: url("../svg/blaek-login-bg.svg") !important;
    background-size: auto 90% !important;
    background-position: right top !important;
    background-repeat: no-repeat !important;
}

/* =======================
   Login container
   ======================= */

.glassmorphism {
    position: relative;
    backdrop-filter: blur(10px) saturate(120%);
    -webkit-backdrop-filter: blur(10px) saturate(120%);
    box-shadow: 0 4px 25px 0 rgba(20, 70, 110, 0.1);
    overflow: hidden;
    background: linear-gradient(315deg, rgba(255, 255, 255, 0.4) 0%, rgba(255, 255, 255, 0.2) 100%);
}

.glassmorphism--hight {
    background: linear-gradient(315deg, rgba(255, 255, 255, 0.92) 0%, rgba(255, 255, 255, 0.92) 100%);
}

.glassmorphism::before {
    position: absolute;
    content: "";
    inset: 0;
    border-radius: inherit;
    padding: 2px;
    background: linear-gradient(225deg, transparent 0%, #fff 100%);
    /* Mask: Only show as border */
    -webkit-mask: linear-gradient(#fff 0 0) content-box,
    linear-gradient(#fff 0 0);
    -webkit-mask-composite: xor;
    mask-composite: exclude;
    pointer-events: none;
    z-index: 1;
}

#keycloak-bg .pf-v5-c-login__main {
    border: none;
    border-radius: 2px;
    margin: 0;
}

/* Hide default Keycloak header */
.pf-v5-c-login__header {
    display: none;
}

/* =======================
   Titles & text
   ======================= */
.pf-v5-c-title {
    font-size: 1.25rem !important;
    font-weight: 500 !important;
    color: var(--color-text-secondary);
    font-family: "Roboto Flex", sans-serif;
}

.pf-v5-c-title .title-highlight {
    font-size: 2.25rem;
    color: var(--color-text-primary);
    margin-bottom: 4rem;
    line-height: 1;
}

#kc-page-subtitle {
    font-size: 1.25rem;
    font-weight: 500;
    color: var(--color-text-secondary);
    font-family: "Roboto Flex", sans-serif;
}

.pf-v5-c-form-control select {
    border: 1px solid var(--color-border-default);
    height: 40px;
}

/* =======================
   Layout tweaks
   ======================= */
.kc-form-buttons {
    display: flex;
    flex-wrap: wrap;
    gap: 0.5rem;
    justify-content: space-between;
}

#kc-form-wrapper,
.kc-form-wrapper {
    padding: 1rem 0 3rem 0;
}

.pf-v5-c-login {
    align-items: center;
    min-height: calc(100% - 133px);
}

.pf-v5-c-login__container {
    grid-template-columns: 37.5rem;
    padding-inline-end: 0;
}

.pf-v5-c-login__main-body {
    padding-block-end: 1.5rem;
}

.pf-v5-c-login__main-footer-band {
    padding: 0;
    text-align: left;
    border: none;
}

/* =======================
   Form labels & helpers
   ======================= */

.label-text, .instruction {
    color: var(--color-text-default);
    font-size: 0.875rem;
    font-weight: 400;
    line-height: 1.6;
}

.label-text a {
    text-decoration: underline;
    color: inherit;
}

.label-text.highlight {
    color: var(--color-text-secondary);
    font-weight: 600;
}

.label-text strong {
    font-weight: 600;
}

.pf-v5-c-form__label,
.pf-v5-c-form__label-text {
    color: var(--color-text-default);
    font-size: 0.75rem;
    font-weight: 600;
}

.pf-v5-c-form__helper-text {
    margin: 0;
    margin-top: 0.25rem;
}

.pf-v5-c-helper-text__item {
    color: var(--color-text-secondary);
    font-size: 0.75rem;
    font-weight: 400;
}

.pf-v5-c-helper-text__item-text {
    margin-block-start: 1.5rem;
    display: block;
    font-size: 0.875rem;
}

.pf-v5-c-helper-text__item-text.pf-m-error {
    margin-block-start: 0.5rem;
}

.pf-v5-c-helper-text__item-text a {
    color: var(--color-primary);
    font-size: 0.875rem;
    font-weight: 600;
}

.kc-password-rules {
    color: var(--color-text-secondary);
    font-size: 0.875rem;
    font-weight: 400;
}

.message-banner {
    padding: 0.75rem 1rem;
    font-size: 0.875rem;
    font-weight: 400;
    color: var(--color-text-secondary);
    background: var(--color-bg-info);
    border-top: 2px solid var(--color-border-info);
    display: flex;
    gap: 1rem;
}

.message-banner.banner-danger {
    background: var(--color-bg-danger);
    border-top: 2px solid var(--color-border-danger);
}

.message-banner .kc-password-rules {
    margin-top: 1rem;
}

/* =======================
   Inputs
   ======================= */
.pf-v5-c-form-control::before,
.pf-v5-c-form-control::after {
    display: none;
}

.pf-v5-c-form-control input,
input.pf-v5-c-form-control {
    height: 40px;
    border: 1px solid var(--color-border-default);
}

.pf-v5-c-form-control input:hover,
input.pf-v5-c-form-control:hover {
    box-shadow: var(--color-focus-ring) 0 0 0 2px;
}

/* =======================
   Utilities
   ======================= */
.info-section {
    display: flex;
    flex-direction: column;
    flex-wrap: wrap;
    gap: 0.5rem;
    padding-top: 1.5rem;
    align-items: flex-start;
}

.flex-column {
    flex-direction: column;
}


.label-with-link {
    display: inline-flex;
    align-items: center;
    flex-wrap: wrap;
    gap: 0.25rem;
    font-weight: 600;
    font-size: 0.875rem;
    color: var(--color-text-secondary);
}

.atom-link {
    font-weight: 600;
    font-size: 0.875rem;
    color: var(--color-primary);
    display: inline-flex;
    align-items: center;
    gap: 0.25rem;
    background-repeat: no-repeat;
    background-size: calc(100% - 1px) 0.1rem;
    background-position: -10000% bottom;
    text-decoration: none;
    outline: none;
    padding: 0;
    background-color: transparent;
    border: none;
}

.atom-link:hover {
    background-image: linear-gradient(var(--color-primary), var(--color-primary));
    background-position: left bottom;
    transition: background-position 0.3s;
}

.atom-link:focus {
    background-image: linear-gradient(var(--color-primary-hover),
    var(--color-primary-hover));
    background-position: left bottom;
    color: var(--color-primary-hover);
    outline: var(--color-link-outline) dotted 1px;
}

.password-group {
    position: relative;
}

.password-input {
    padding-right: 3rem;
}

.password-toggle {
    position: absolute;
    top: 50%;
    right: 0.75rem;
    transform: translateY(-50%);

    background: transparent;
    border: none;
    padding: 0;
    margin: 0;

    cursor: pointer;
    color: var(--color-text-secondary);

    display: flex;
}

.cancel-label {
    display: flex;
    align-items: center;
    gap: 0.25rem;
}

.maintenance-wrapper {
    margin-bottom: 1.5rem;
}

.activation-info-subtitle {
    font-size: 0.875rem;
    line-height: 1.25rem;
    letter-spacing: 0.01em;
    color: var(--color-text-secondary);
    margin-bottom: 1rem;
}

/* =======================
   For Mobile
   ======================= */

@media (max-width: 768px) {
    body#keycloak-bg {
        background-position: center !important;
        background-size: cover !important;
    }
}
